<template>
  <div>
    <div class="flex justify-between items-top">
      <div class="text-h4 q-mb-md">
        Jízdy
      </div>
      <div>
        <q-btn
          class="admin-timetable-add"
          color="accent"
          icon="timeline"
          icon-right="add"
          label="Přidat"
          @click="addClick"
        />
      </div>
    </div>

    <q-table
      grid
      :rows="rows"
      :columns="columns"
      row-key="name"
      :pagination="initialPagination"
      :loading="loadingTable"
    >
      <template #item="props">
        <div class="q-pa-xs col-xs-12 col-sm-6 col-md-4">
          <q-card>
            <q-list>
              <q-item
                v-for="col in props.cols"
                :key="col.id"
              >
                <q-item-section>
                  <q-item-label>{{ col.label }}</q-item-label>
                </q-item-section>
                <q-item-section>
                  <q-item-label
                    caption
                  >
                    {{ col.value }}
                  </q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
            <q-separator />
            <q-card-section class="flex flex-center">
              <q-btn
                class="q-ml-xs q-mb-xs"
                color="primary"
                label="Upravit"
                size="sm"
                @click="onUpdate(props.row.id)"
              >
                <template #loading>
                  <q-spinner-gears />
                </template>
              </q-btn>

              <q-btn
                class="q-ml-xs q-mb-xs"
                color="negative"
                label="Smazat"
                size="sm"
                @click="onDelete(props.row.id)"
              >
                <template #loading>
                  <q-spinner-gears />
                </template>
              </q-btn>
            </q-card-section>
          </q-card>
        </div>
      </template>

      <template #loading>
        <q-inner-loading
          showing
          color="primary"
        />
      </template>
    </q-table>
  </div>
</template>

<script lang="ts">
import { ref } from '@vue/reactivity'
import _ from 'lodash'
import { useQuasar } from 'quasar'
import { JourneyModel } from 'web_trains_types'

import JourneyAddDialog from '@/components/Timetable/JourneyAddDialog.vue'
import { journeyService } from '@/service'

const columns = [
  {
    name: 'from',
    field: (row: JourneyModel) => row.stationFrom ? row.stationFrom.name : '',
    label: 'Z',
    required: true
  },
  {
    name: 'to',
    field: (row: JourneyModel) => row.stationTo ? row.stationTo.name : '',
    label: 'Do',
    required: true
  },
  {
    name: 'train',
    field: (row: JourneyModel) => row.train ? row.train.name : '',
    label: 'Vlak',
    required: true
  },
  {
    name: 'speed',
    field: 'speed',
    label: 'Rychlost',
    required: true
  },
  {
    name: 'direction',
    field: 'direction',
    label: 'Směr',
    required: true
  }
]

const initialPagination = {
  page: 1,
  rowsPerPage: 9
}

export default {
  name: 'Journey',
  setup (): any {
    const $q = useQuasar()

    const loadingTable = ref(true)
    const rows = ref<JourneyModel[]>()

    const loadData = () => {
      loadingTable.value = true

      journeyService.getAll()
        .then((data) => {
          rows.value = data
        })
        .finally(() => {
          loadingTable.value = false
        })
    }

    const addClick = () => {
      $q.dialog({
        component: JourneyAddDialog
      })
        .onOk(loadData)
    }

    loadData()

    const onDelete = (id: number) => {
      loadingTable.value = true

      journeyService.del(id)
        .then(() => {
          if (rows.value === undefined) {
            return
          }

          _.remove(rows.value, (obj) => obj.id === id)

          $q.notify({
            message: 'Jízda smazána',
            type: 'positive'
          })
        })
        .finally(() => { loadingTable.value = false })
    }

    const onUpdate = (id: number) => {
      $q.dialog({
        component: JourneyAddDialog,
        componentProps: {
          id: id
        }
      })
        .onOk(loadData)
    }

    return {
      addClick,
      columns,
      initialPagination,
      loadingTable,
      rows,
      loadData,
      onDelete,
      onUpdate
    }
  }
}

</script>
